src/project/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from apps.social_media.integration import Integration

urlpatterns = [
    integ.urlpatterns for integ in Integration.all()
] + [
    path('accounts/', include('django.contrib.auth.urls')),
    path('admin/', admin.site.urls),
    path('api/', include('apps.api.urls')),
    path('', include('apps.dashboard.urls')),
]

if settings.DEBUG:
    import debug_toolbar
    urlpatterns += [
        path('__debug__/', include(debug_toolbar.urls)),
    ]
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

src/apps/telegram/models.py
import inspect
from django.db import models
from django.contrib.auth.models import User
from django.utils.functional import cached_property
from django.utils.module_loading import import_string
from django.core.exceptions import ValidationError

from . import connection


TELEGRAM_ID_BYTES = 32


class TelegramLogin(models.Model):
    user = models.OneToOneField(User, models.CASCADE, related_name="telegram_login")
    telegram_id = models.CharField(max_length=TELEGRAM_ID_BYTES, db_index=True, unique=True)
    first_name = models.CharField(max_length=128)
    last_name = models.CharField(max_length=128)
    username = models.CharField(max_length=128)
    icon_url = models.CharField(max_length=128)

    def get_api_object(self, client=None):
        data = {
            "id": self.telegram_id,
            "first_name": self.first_name,
            "last_name": self.last_name,
        }
        if self.username:
            data["username"] = self.username

        return connection.TelegramAuthedUser(
            connection.get_client(client),
            self.telegram_id,
            self.icon_url,
            data
        )


class TelegramUserBot(models.Model):
    user = models.ForeignKey(User, models.CASCADE, related_name="telegram_bots")
    token = models.CharField(max_length=64)
    enabled = models.BooleanField(default=True)

    @cached_property
    def client(self):
        return connection.controller.bot(self.token)

    @property
    def me(self):
        if not self.client:
            return None
        return self.client.me

    class Meta:
        unique_together = [
            ["user", "token"]
        ]

    def __str__(self):
        try:
            return "@" + self.me.username
        except AttributeError:
            return "Bot by " + self.user.username


class BotDebugMode(models.Model):
    token = models.CharField(max_length=64, unique=True)
    debug_enabled = models.BooleanField(blank=True, default=False)
    debug_as = models.ForeignKey(TelegramUserBot, models.SET_NULL, null=True, blank=True)


def _bot_class(name):
    try:
        cls = import_string(name)
    except Exception:
        raise ValidationError("%s is not importable")

    if not inspect.isclass(cls):
        raise ValidationError("%s is not a class")

    from .advanced_bot import AdvancedBot

    if not issubclass(cls, AdvancedBot):
        raise ValidationError("%s is not a subclass of AdvancedBot")


class AdvancedBot(models.Model):
    bot = models.OneToOneField(TelegramUserBot, models.CASCADE, related_name="advanced_bot")
    python_class = models.CharField(max_length=128, validators=[_bot_class], default="apps.telegram.advanced_bot.AdvancedBot")

    def get_runner(self):
        cls = import_string(self.python_class)
        return cls(self)


class AdvancedBotGroup(models.Model):
    telegram_id = models.CharField(max_length=TELEGRAM_ID_BYTES)
    name = models.CharField(max_length=128)
    bot = models.ForeignKey(AdvancedBot, models.CASCADE, related_name="groups")
    approved = models.DateTimeField(null=True)
    admin = models.BooleanField(default=False)

    class Meta:
        unique_together = [
            ["bot", "telegram_id"]
        ]


class AdvancedBotAdmin(models.Model):
    bot = models.ForeignKey(AdvancedBot, models.CASCADE, related_name="admins")
    telegram_id = models.CharField(max_length=TELEGRAM_ID_BYTES)
    name = models.CharField(max_length=128)

    class Meta:
        unique_together = [
            ["bot", "telegram_id"]
        ]

src/apps/telegram/forms.py
from django import forms
from django.core.validators import ValidationError
from . import models
from . import connection


class BotChoiceWidget(forms.RadioSelect):
    option_template_name = 'telegram/bot_radio_option.html'

    def __init__(self, attrs=None, choices=()):
        attrs = attrs or {}
        attrs.setdefault("class", "bot-choice")
        super().__init__(attrs, choices)


class BotChoiceField(forms.ChoiceField):
    widget = BotChoiceWidget

    def set_user(self, user):
        self.choices = [
            ("", connection.BotClient.instance())
        ] + [
            (bot.client.token, bot.client)
            for bot in models.TelegramUserBot.objects.filter(user=user)
        ]

    def to_python(self, value):
        for tok, tg in self.choices:
            if tok == value:
                return tg
        return None

    def validate(self, value):
        if not isinstance(value, connection.BotClient):
            raise ValidationError("Invalid bot")


class ComposeForm(forms.Form):
    group = forms.CharField()
    message = forms.CharField(widget=forms.Textarea)
    bot = BotChoiceField()

    def __init__(self, data, user, *a, **kw):
        super().__init__(data or None, *a, **kw)
        self.fields["bot"].set_user(user)


def label_attr_field(label, field, **kw):
    kw["widget"] = field.widget(attrs={"placeholder": label, "title": label})
    return field(**kw)


class InlineKeyboardButtonForm(forms.Form):
    text = label_attr_field("Text", forms.CharField, required=False)
    url = label_attr_field("Link", forms.URLField, required=True)
    new_row = forms.BooleanField(required=False)


InlineKeyboardButtonFormSet = forms.formset_factory(InlineKeyboardButtonForm, can_order=True, can_delete=True, extra=0)


DebugModeForm = forms.modelform_factory(models.BotDebugMode, exclude=["token"])

AdvancedBotForm = forms.modelform_factory(models.AdvancedBot, exclude=["bot"])

src/apps/telegram/templates/telegram/bot_details.html
{% extends "logged_in.html" %}

{% block content %}
<h1>Telegram integration</h1>

<h2>@{{ bot.username }}</h2>
<table class="table">
    <tr><th>Name</th><td>{{ bot.first_name }}</td></tr>
    <tr><th>Icon</th><td><img src="{{ bot.profile_photo.url }}" class="profile-pic"/></td></tr>
    <tr><th>Username</th><td><a href="{{ bot.link }}">@{{ bot.username }}</a></td></tr>
    {% if dbot %}
        <tr><th>Token</th><td style="font-size: small">{{ bot.client.token }}</td></tr>
    {% endif %}
    {% if hook.ok %}
        {% if hook.result.url %}
            <tr><th>Webhook</th><td>{{ hook.result.url }}</td></tr>
        {% endif %}
    {% else %}
        <tr><th>Webhook</th><td>Error</td></tr>
    {% endif %}
    <tr><th>Actions</th><td>
        <ul class="buttons">
            {% if dbot %}
                <li><a href="{% url "telegram:bot_remove" bot.client.token %}">Remove</a></li>
                <li><a href="{% url "telegram:bot_compose" %}?token={{ bot.client.token }}">Compose</a></li>

                {% if dbot.enabled %}
                    <li><a href="{% url "telegram:bot_disable" bot.client.token %}">Disable</a></li>
                {% else %}
                    <li><a href="{% url "telegram:bot_enable" bot.client.token %}">Enable</a></li>
                {% endif %}
            {% endif %}
            {% if hook.ok and hook.result.url %}
                <li><a href="{% url "telegram:bot_delete_hook" bot.client.token %}">Delete Webhook</a></li>
            {% endif %}
            <li><a href="{% url "telegram:bot_test" bot.client.token %}">API Test</a></li>
        </ul>
    </td></tr>
</table>

<h2>Commands</h2>
{% if commands is None %}
    <p>Couldn't fetch commands</p>
{% elif not commands %}
    <p>No commands set</p>
{% else %}
    <table class="table">
    {% for command in commands %}
        <tr><th>/{{ command.command }}</th><td>{{ command.description }}</td></tr>
    {% endfor %}
    </table>
{% endif %}

{% if exceptions %}
    <h2>Exceptions</h2>
    <pre>{% for exception in exceptions %}{{ exception }}{% endfor %}</pre>

    <ul class="buttons">
        <li><a href="{% url "telegram:bot_exceptions_clear" bot.client.token %}">Clear</a></li>
    </ul>
{% endif %}


{% if debug_mode_form and user.is_superuser %}
<h2>Debug mode</h2>
<form method="post">
    {% csrf_token %}
    {{ debug_mode_form.as_p }}
    <button type="submit">Save</button>
</form>
{% endif %}


<h2>Advanced</h2>

<form method="post" action="{% url 'telegram:bot_advanced' bot.client.token %}">
    {% csrf_token %}
    {{ advanced_form }}
    <button type="submit">Save</button>
</form>

{% if advanced_bot %}
    <h3>Groups</h3>

    <table class="table">
        <tr><th>Name</th><th>ID</th><th>Approved</th><th>Admin</th><th>Actions</th></tr>
        {% for group in advanced_bot.groups.all %}
            <tr><td>{{ group.name }}</td><td>{{ group.id }}</td><td>{{ group.approved }}</td><td>{{ group.admin }}</td>
            <td>
                <ul class="buttons">
                    {% if not group.approved %}
                        <li><a href="{% url "telegram:bot_advanced_group_approve" bot.client.token group.id %}">Approve</a></li>
                    {% elif not group.admin %}
                        <li><a href="{% url "telegram:bot_advanced_group_make_admin" bot.client.token group.id %}">Make Admin</a></li>
                    {% endif %}
                    <li><a href="{% url "telegram:bot_advanced_group_delete" bot.client.token group.id %}">Delete</a></li>
                </ul>
            </td>
        {% endfor %}
    </table>
{% endif %}

<h2>Stats</h2>
<table class="table">
    <tr><th>ID</th><th>Username</th><th>Hits</th><th>Rate</th><th>Blocked</th><th>Queries</th></tr>
    {% for stat in bot.client.query_stats %}
        <tr>
            <td>{{ stat.id }}</td><td>{{ stat.username }}</td><td>{{ stat.count }}</td><td>{{ stat.rate }}</td><td>{{ stat.blocked }}</td>
            <td><ul>
                {% for query in stat.top_queries %}
                    <li>{{ query.1 }} - {{ query.0 }}</li>
                {% endfor %}
            </ul></td>
        </tr>
    {% endfor %}
</table>


{% endblock %}

src/apps/telegram/templates/telegram/bot_radio_option.html
{% include "django/forms/widgets/input.html" %}
<label{% if widget.attrs.id %} for="{{ widget.attrs.id }}"{% endif %}>
{% with bot=widget.label.me %}
    <img src="{{ bot.profile_pic.file.url }}" class="profile-pic-small"/>
    @{{ bot.username }}
{% endwith %}</label>

src/apps/telegram/templates/telegram/bot_row.html
{% load fontawesome_5 %}
<tr>
    {% if bot.me is not None %}
        <td>{{ bot.me.first_name }}</td>
        <td>
            {% if bot.client.exceptions %}
                <span style="color: red">{% fa5_icon "exclamation-triangle" "fas" %}</span>
            {% endif %}
            @{{ bot.me.username }}
        </td>
        <td><a href="{{ bot.me.link }}">{{ bot.me.link }}</a></td>
        <td><img src="{{ bot.me.profile_photo.url }}" class="profile-pic"/></td>
    {% else %}
        <td colspan="4">
            <span style="color: red">{% fa5_icon "exclamation-triangle" "fas" %}</span>
            Bot not loaded
        </td>
    {% endif %}
    <td style="font-size: small">{{ bot.token }}</td>
    <td>
        <ul class="buttons" style="flex-wrap: nowrap;">
        {% if actions %}
            <li><a href="{% url "telegram:bot_remove" bot.token %}" title="Remove">{% fa5_icon "trash" "fas" %}</a></li>
            <li><a href="{% url "telegram:bot_details" bot.token %}" title="Details">{% fa5_icon "info-circle" "fas" %}</a></li>
            {% if bot.enabled %}
                <li><a href="{% url "telegram:bot_disable" bot.token %}" title="Disable">{% fa5_icon "pause-circle" "far" %}</a></li>
            {% else %}
                <li><a href="{% url "telegram:bot_enable" bot.token %}" title="Enable">{% fa5_icon "play-circle" "far" %}</a></li>
            {% endif %}
        {% else %}
            <li><span>Built-in</span></li>
            <li><a href="{% url "telegram:bot_details" bot.token %}" title="Details">{% fa5_icon "info-circle" "fas" %}</a></li>
        {% endif %}
            <li><a href="{% url "telegram:bot_reconnect" bot.token %}" title="Reconnect">{% fa5_icon "sync" "fas" %}</a></li>
        </ul>
    </td>
</tr>

src/apps/telegram/templates/telegram/bot_test.html
{% extends "logged_in.html" %}
{% load fontawesome_5 %}

{% block content %}
<h1>Telegram integration</h1>

<h2>Test @{{ bot.me.username }}</h2>

<p><a href="https://core.telegram.org/bots/api#available-methods">Bot API</a></p>

{% include "parts/api_test_form.html" %}

{% endblock %}

src/apps/telegram/templates/telegram/button_form.html
{% load fontawesome_5 %}
<div id="{{ form.prefix }}-wrapper">
{% include "parts/form_errors.html" with include_fields=True %}
{{ form.text }}
{{ form.url }}
<input type="checkbox" onchange="button_newline(this);" name="{{ form.new_row.name }}" id="{{ form.new_row.id_for_label }}" autocomplete="off" style="display: none" />
<ul class="buttons no-margin" style="display: inline-flex">
    <li><label for="{{ form.new_row.id_for_label }}" title="New Line">{% fa5_icon "paragraph" "fas" %}</label></li>
    <li><a onclick="button_delete('{{ form.prefix }}-wrapper');" title="Remove">{% fa5_icon "trash-alt" "fas" %}</a></li>
</ul>
</div>

src/apps/telegram/templates/telegram/compose.html
{% extends "logged_in.html" %}
{% load static %}

{% block content %}
    <form method="post">
        {% csrf_token %}
        <table>
            {{ form }}
        </table>

        {{ button_formset.management_form }}
        <div id="buttons_formset">
            {% for button_form in button_formset %}
                {% include "telegram/button_form.html" with form=button_form %}
            {% endfor %}
        </div>
        <div id="buttons_formset_template" style="display: none;">
            {% include "telegram/button_form.html" with form=button_formset.empty_form %}
        </div>

        <ul class="buttons" >
            <li><button type="Submit">Submit</button></li>
            <li><a onclick="button_add()">Add button</a></li>
        </ul>

        <aside class="emoji-board" id="emoji_board" style="width: auto; height: 512px;"></aside>
        <script>
            let board = emoji_board({
                element: "#emoji_board",
                max_version: [12, 0],
                targets: ["#id_message"],
            });
            {% for button_form in button_formset %}
            board.add_target("#{{ button_form.text.id_for_label }}");
            {% endfor %}

            function button_add()
            {
                let total_forms = document.getElementById("id_form-TOTAL_FORMS");
                let button_no = Number(total_forms.value);
                let template = document.getElementById("buttons_formset_template").innerHTML.replace(/__prefix__/g, button_no);
                total_forms.value = button_no+1;

                let parent = document.getElementById("buttons_formset");
                parent.insertAdjacentHTML("beforeend", template);
                board.add_target(`#id_form-${button_no}-text`);
            }

            function button_newline(input)
            {
                let label = input.labels[0];

                if ( input.checked )
                    label.classList.add("active");
                else
                    label.classList.remove("active");
            }

            function button_delete(id)
            {
                let element = document.getElementById(id);
                element.parentNode.removeChild(element);
            }
        </script>
    </form>
{% endblock %}


{% block extra_head %}
    {{ block.super }}

    <link rel="stylesheet" type="text/css" href="{% static "emoji-board.css" %}"/>
    <script src="{% static "emoji-board.js" %}"></script>
{% endblock %}

src/apps/telegram/templates/telegram/manage.html
{% extends "logged_in.html" %}
{% load telegram %}

{% block content %}
    <h1>Telegram integration</h1>

    <h2>User</h2>
    {% if connected_user %}
        <table class="table">
            <tr><th>Name</th><td>{{ connected_user.display_name }}</td></tr>
            <tr><th>Icon</th><td><img src="{{ connected_user.icon_url }}" class="profile-pic"/></td></tr>
            {% if connected_user.username %}
            <tr><th>Username</th><td><a href="{{ connected_user.link }}">@{{ connected_user.username }}</td></tr>
            {% endif %}
            <tr><th>ID</th><td>{{ connected_user.user_id }}</td></tr>
            <tr><th>Actions</th><td>
                <ul class="buttons">
                    <li><a href="{% url "telegram:disconnect" %}">Disconnect</a></li>
                </ul>
            </td></tr>
        </table>
    {% else %}
        {% telegram_login_widget "telegram:connect" %}
    {% endif %}
    <p><a href="{% url "telegram:bot_compose" %}">Compose</a></p>

    <h2>Bots</h2>

    <table class="table">
        <thead>
            <tr>
                <th>Name</th>
                <th>Username</th>
                <th>Link</th>
                <th>Icon</th>
                <th>Token</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
            {% if user.is_superuser %}
                {% for bot in builtin_bots %}
                    {% include "telegram/bot_row.html" with bot=bot actions=False %}
                {% endfor %}
            {% endif %}
            {% for bot in bots %}
                {% include "telegram/bot_row.html" with bot=bot actions=True %}
            {% endfor %}
        </tbody>
    </table>

    <form method="post" action="{% url "telegram:bot_add" %}">
        {% csrf_token %}
        <p>
            <label for="add_bot_token">Token</label>
            <input type="text" id="add_bot_token" name="token" />
            <button type="sumbit">Add bot</button>
        </p>
    </form>
{% endblock %}